<?xml version="1.0" encoding="UTF-8"?>
<project xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance"
         xmlns="http://maven.apache.org/POM/4.0.0"
         xsi:schemaLocation="http://maven.apache.org/POM/4.0.0 http://maven.apache.org/xsd/maven-4.0.0.xsd">
    <parent>
        <artifactId>task-manager</artifactId>
        <groupId>com.tsconsulting.dsubbotin.tm</groupId>
        <version>1.33.2</version>
    </parent>

    <modelVersion>4.0.0</modelVersion>
    <artifactId>tm-client</artifactId>
    <version>0.1.2</version>

    <name>task-manager-client</name>
    <url>http://www.tsconsulting.com/</url>

    <properties>
        <project.build.sourceEncoding>UTF-8</project.build.sourceEncoding>
        <maven.compiler.source>15</maven.compiler.source>
        <maven.compiler.target>15</maven.compiler.target>
    </properties>

    <developers>

        <developer>
            <id>dsubbotin</id>
            <name>Dmitriy Subbotin</name>
            <email>dsubbotin@tsconsulting.com</email>
            <organization>TechnoServConsulting</organization>
            <url>http://www.tsconsulting.com/</url>
        </developer>

    </developers>

    <scm>
        <connection>scm:svn:http://none</connection>
        <developerConnection>scm:svn:https://none</developerConnection>
        <url>http://none</url>
    </scm>

    <profiles>

        <profile>
            <id>UNIT</id>
            <activation>
                <activeByDefault>true</activeByDefault>
            </activation>
            <properties>
                <test.category>com.tsconsulting.dsubbotin.tm.marker.UnitCategory</test.category>
            </properties>
        </profile>

        <profile>
            <id>INTEGRATION</id>
            <activation>
                <activeByDefault>false</activeByDefault>
            </activation>
            <properties>
                <test.category>com.tsconsulting.dsubbotin.tm.marker.SoapCategory</test.category>
            </properties>
        </profile>

        <profile>
            <id>SOAP</id>
            <activation>
                <activeByDefault>false</activeByDefault>
            </activation>
            <build>
                <plugins>
                    <plugin>
                        <groupId>org.apache.cxf</groupId>
                        <artifactId>cxf-codegen-plugin</artifactId>
                        <version>3.4.3</version>
                        <executions>
                            <execution>
                                <id>generate-sources</id>
                                <phase>generate-sources</phase>
                                <configuration>
                                    <sourceRoot>${project.basedir}/src/main/java</sourceRoot>
                                    <wsdlOptions>

                                        <wsdlOption>
                                            <wsdl>http://localhost:8081/ProjectEndpoint?wsdl</wsdl>
                                        </wsdlOption>

                                        <wsdlOption>
                                            <wsdl>http://localhost:8081/TaskEndpoint?wsdl</wsdl>
                                        </wsdlOption>

                                        <wsdlOption>
                                            <wsdl>http://localhost:8081/ProjectTaskEndpoint?wsdl</wsdl>
                                        </wsdlOption>

                                        <wsdlOption>
                                            <wsdl>http://localhost:8081/AdminUserEndpoint?wsdl</wsdl>
                                        </wsdlOption>

                                        <wsdlOption>
                                            <wsdl>http://localhost:8081/UserEndpoint?wsdl</wsdl>
                                        </wsdlOption>

                                        <wsdlOption>
                                            <wsdl>http://localhost:8081/SessionEndpoint?wsdl</wsdl>
                                        </wsdlOption>

                                        <wsdlOption>
                                            <wsdl>http://localhost:8081/AdminEndpoint?wsdl</wsdl>
                                        </wsdlOption>

                                    </wsdlOptions>
                                </configuration>
                                <goals>
                                    <goal>wsdl2java</goal>
                                </goals>
                            </execution>
                        </executions>
                    </plugin>
                </plugins>
            </build>
        </profile>

    </profiles>

    <dependencies>

        <dependency>
            <groupId>org.projectlombok</groupId>
            <artifactId>lombok</artifactId>
            <version>1.18.20</version>
            <scope>provided</scope>
        </dependency>

        <dependency>
            <groupId>org.jetbrains</groupId>
            <artifactId>annotations</artifactId>
            <version>20.1.0</version>
            <scope>provided</scope>
        </dependency>

        <dependency>
            <groupId>org.reflections</groupId>
            <artifactId>reflections</artifactId>
            <version>0.9.12</version>
            <scope>compile</scope>
        </dependency>

        <dependency>
            <groupId>com.jcabi</groupId>
            <artifactId>jcabi-manifests</artifactId>
            <version>1.1</version>
            <scope>compile</scope>
        </dependency>

        <dependency>
            <groupId>org.slf4j</groupId>
            <artifactId>slf4j-simple</artifactId>
            <version>1.7.30</version>
        </dependency>

        <dependency>
            <groupId>com.sun.xml.ws</groupId>
            <artifactId>rt</artifactId>
            <version>2.3.1</version>
        </dependency>

        <dependency>
            <groupId>junit</groupId>
            <artifactId>junit</artifactId>
            <version>4.11</version>
            <scope>test</scope>
        </dependency>

    </dependencies>

    <build>

        <finalName>task-manager-client</finalName>

        <plugins>

            <plugin>
                <groupId>org.apache.maven.plugins</groupId>
                <artifactId>maven-jar-plugin</artifactId>
                <version>3.2.0</version>
                <configuration>
                    <archive>
                        <manifest>
                            <addClasspath>true</addClasspath>
                            <mainClass>com.tsconsulting.dsubbotin.tm.Application</mainClass>
                        </manifest>
                        <manifestEntries>
                            <buildNumber>${buildNumber}</buildNumber>
                            <version>${project.version}</version>
                            <buildVersion>${project.version}-RELEASE.${buildNumber}</buildVersion>
                            <timestamp>${timestamp}</timestamp>
                            <artifactId>${project.artifactId}</artifactId>
                            <groupId>${project.groupId}</groupId>
                            <developer>Dmitriy Subbotin</developer>
                            <email>dsubbotin@tsconsulting.com</email>
                        </manifestEntries>
                    </archive>
                </configuration>
            </plugin>

            <plugin>
                <groupId>org.apache.maven.plugins</groupId>
                <artifactId>maven-shade-plugin</artifactId>
                <version>3.2.4</version>
                <executions>
                    <execution>
                        <phase>package</phase>
                        <goals>
                            <goal>shade</goal>
                        </goals>
                        <configuration>
                            <transformers>
                                <transformer
                                        implementation="org.apache.maven.plugins.shade.resource.ManifestResourceTransformer">
                                    <mainClass>com.tsconsulting.dsubbotin.tm.Application</mainClass>
                                </transformer>
                            </transformers>
                            <filters>
                                <filter>
                                    <artifact>*:*</artifact>
                                    <excludes>
                                        <exclude>META-INF/*.SF</exclude>
                                        <exclude>META-INF/*.DSA</exclude>
                                        <exclude>META-INF/*.RSA</exclude>
                                    </excludes>
                                </filter>
                            </filters>
                        </configuration>
                    </execution>
                </executions>
            </plugin>

            <plugin>
                <groupId>org.codehaus.mojo</groupId>
                <artifactId>buildnumber-maven-plugin</artifactId>
                <version>1.4</version>
                <executions>
                    <execution>
                        <phase>generate-resources</phase>
                        <goals>
                            <goal>create</goal>
                        </goals>
                    </execution>
                </executions>
                <configuration>
                    <revisionOnScmFailure>no.scm.config.in.pom</revisionOnScmFailure>
                    <doCheck>true</doCheck>
                    <doUpdate>false</doUpdate>
                    <format>{0,number}</format>
                    <items>
                        <item>buildNumber</item>
                        <item>timestamp</item>
                    </items>
                </configuration>
            </plugin>

            <plugin>
                <groupId>org.apache.maven.plugins</groupId>
                <artifactId>maven-surefire-plugin</artifactId>
                <version>2.22.2</version>
                <configuration>
                    <groups>${test.category}</groups>
                </configuration>
            </plugin>

        </plugins>

    </build>

</project>